$mail = <<EOL;
From xxxx
Date: Test
From: Bala
To: Walter
X-Mailer: mailprog
Subject: original-subject
X-Mailer: dudelidud
Message-ID: <200231321\@asdfsadf.who>

Mailtext
balbal
X-Mailer: TLTADF
EOL

    my ($alias, $title, $mid) = ('ANN', 'titelkrams bla', '20020220@nowhere.no');

    replace_header_field( \$mail, 'X-Mailer', 'greg' );
replace_header_field(\$mail, "Subject", "ADD: $alias: $title" );
(my $mid_tmp = $mid) =~ s/-at-/\@/;
replace_header_field(\$mail, "Message-ID", "<$mid_tmp>" );

my $sign_ID = "0xtttttt";
    if (defined $sign_ID) {
       replace_header_field(\$mail, "X-mwiki-sign-ID", "$sign_ID" );
    }

print $mail;

sub replace_header_field {
    my ($text_r, $field, $new_value) = @_;

    my ($header, $body) = split(/\n\n/, $$text_r, 2);
    my @header = split('\n', $header);
    
    my $inserted = 0;
    for(my $i=0; $i <= $#header; $i++) {
	if ( @header[$i] =~ /^$field:\s(.*?)$/i ) {
	    my $value = $1;

	    if ($value ne $new_value) {
		@header[$i] = "X-Original-$field: $value";
		if ( $inserted == 0 ) {
		    @header[$i] .= "\n$field: $new_value";
		    $inserted = 1;
		}
	    }
	}	
    }	
    
    if ( $inserted == 0 ) {
	push(@header, "$field: $new_value");
	$inserted = 1;
    }

    $header = join("\n", @header);
    $$text_r = "$header\n\n$body";

    return 0;
}
